#ifndef _FLVTYPES_H_
#define _FLVTYPES_H_

#define FLV_AUDIODATA     8
#define FLV_VIDEODATA     9
#define FLV_SCRIPTDATA    18

#define FLV_AUDIO_PCM     0
#define FLV_AUDIO_ADPCM   1
#define FLV_AUDIO_MP3     2
#define FLV_AUDIO_PCMLE   3
#define FLV_AUDIO_NELLY16 4
#define FLV_AUDIO_NELLY8  5
#define FLV_AUDIO_NELLY   6
#define FLV_AUDIO_ALAW    7
#define FLV_AUDIO_ULAW    8
#define FLV_AUDIO_AAC     10
#define FLV_AUDIO_SPEEX   11

#define FLV_VIDEO_JPEG    1
#define FLV_VIDEO_H263    2
#define FLV_VIDEO_SCREEN  3
#define FLV_VIDEO_VP6     4
#define FLV_VIDEO_VP6A    5
#define FLV_VIDEO_SCREEN2 6
#define FLV_VIDEO_AVC     7

typedef struct {
	__int64         pos;
	int             size;
	unsigned long   pres_time;
} FLVSampleInfo;

#include <PshPack1.h>

typedef struct {
	char            Signature[3];
	unsigned char   Version;
	unsigned char   TypeFlags;
	unsigned long   DataOffset;
} FLVHeader;

typedef struct {
	unsigned long   PreviousTagSize;
	unsigned char   TagType;
	unsigned char   DataSize[3];
	unsigned char   Timestamp[3];
	unsigned char   TimestampExtended;
	unsigned char   StreamID[3];
} FLVTag;

#include <PopPack.h>

#endif	// _FLVTYPES_H
