#ifndef _INPUTFILEFLV_H_
#define _INPUTFILEFLV_H_

class InputFileFLV : public vdxunknown<IVDXInputFile> {

private:
	bool guiDlgMessageLoop(HWND hDlg);
	static BOOL CALLBACK FindContextWindow(HWND hwnd, LPARAM lParam);
	static INT_PTR CALLBACK ParseDialogProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

	bool ParseFLVTags();
	void ParseFileRoot();

	bool fAbort;
	uint32 uiFlags;

	static char *time_to_string(double seconds);
	static void UpdateDlgAudio(HWND hDlg, const class AudioTrackFLV *at);
	static void UpdateDlgVideo(HWND hDlg, const class VideoTrackFLV *at);
	static INT_PTR CALLBACK InfoDlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);

public:
	InputFileFLV(const VDXInputDriverContext& context, uint32 flags);
	~InputFileFLV();

	// IVDXUnknown
	int         VDXAPIENTRY AddRef();
	int         VDXAPIENTRY Release();
	void       *VDXAPIENTRY AsInterface(uint32 iid);


	void VDXAPIENTRY Init(const wchar_t *szFile, IVDXInputOptions *opts);
	bool VDXAPIENTRY Append(const wchar_t *szFile);

	bool VDXAPIENTRY PromptForOptions(VDXHWND hwndParent, IVDXInputOptions **);
	bool VDXAPIENTRY CreateOptions(const void *buf, uint32 len, IVDXInputOptions **);
	void VDXAPIENTRY DisplayInfo(VDXHWND hwndParent);

	bool VDXAPIENTRY GetVideoSource(int index, IVDXVideoSource **);
	bool VDXAPIENTRY GetAudioSource(int index, IVDXAudioSource **);

	long ReadData(void *lpBuffer, __int64 offset, int bytes);

protected:
	WinFile        mFile;

	FLVHeader      flv_header;

	class VideoTrackFLV *video;
	class AudioTrackFLV *audio;

	const VDXInputDriverContext& mContext;
};

#endif	// _INPUTFILEFLV_H_
