#ifndef _WINFILE_H_
#define _WINFILE_H_

class WinFile {

private:
	enum { WF_BUFFERSIZE = 65536 };

	BYTE            m_Buffer[WF_BUFFERSIZE];
	LARGE_INTEGER   m_Pos;
	LARGE_INTEGER   m_Size;
	HANDLE          m_hFile;
	int             m_CurByte;
	int             m_CurBit;

	void            Refresh();
	bool            Open(HANDLE h);

public:
	WinFile();
	~WinFile();

	bool     OpenA(const char *pFileName);
	bool     OpenW(const wchar_t *pFileName);

	__int64  Size() const { return m_Size.QuadPart; }
	__int64  Pos()  const { return m_Pos.QuadPart;  }

	bool     EndOfFile() const { return (m_Pos.QuadPart >= m_Size.QuadPart); }

	bool     Seek(__int64 iAbsPos);
	long     Read(void *pBuffer, int iBytes);
	int      NextByte();

	void     AlignToByte();
	int      NextBit();
	int      GetBits(int nBits);
};

#endif	// _WINFILE_H_
